local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert

-- Add Module
local LayoutAttrib = {}
LayoutAttrib.__index = LayoutAttrib
BaikCore.LayoutAttrib = LayoutAttrib

-- Constants
local CLASS = "LayoutAttrib"
local UNUSED = -1

-- LayoutAttrib API
function LayoutAttrib:Create(width, height, anchor, x, y)
    if not width then
        width = UNUSED
    end
    if not height then
        height = UNUSED
    end
    Assert:Number(width)
    Assert:Number(height)
    Assert:String(anchor)
    Assert:String(anchor)
    Assert:Number(x)
    Assert:Number(y)

    local self = {}
    setmetatable(self, LayoutAttrib)

    -- Setup member variables
    self.class = TYPE
    self.width = width
    self.height = height
    self.anchor = anchor
    self.anchorTo = anchorTo
    self.x = x
    self.y = y

    return self
end

function LayoutAttrib:SyncRegion(region, clearPoints)
    -- Default clearPoints value to false
    if not clearPoints then
        clearPoints = false
    end
    Assert:Table(region)
    Assert:Boolean(clearPoints)

    if clearPoints then
        region:ClearAllPoints()
    end

    if self.width ~= UNUSED then
        region:SetWidth(self.width)
    end

    if self.height ~= UNUSED then
        region:SetHeight(self.height)
    end

    region:SetPoint(self.anchor, self.x, self.y)
end
